## NMSettingDcb

NMSettingDcb — Connection properties for Data Center Bridging

## Functions

NMSetting * | nm_setting_dcb_new ()
NMSettingDcbFlags | nm_setting_dcb_get_app_fcoe_flags ()
gint | nm_setting_dcb_get_app_fcoe_priority ()
const char * | nm_setting_dcb_get_app_fcoe_mode ()
NMSettingDcbFlags | nm_setting_dcb_get_app_iscsi_flags ()
gint | nm_setting_dcb_get_app_iscsi_priority ()
NMSettingDcbFlags | nm_setting_dcb_get_app_fip_flags ()
gint | nm_setting_dcb_get_app_fip_priority ()
NMSettingDcbFlags | nm_setting_dcb_get_priority_flow_control_flags ()
gboolean | nm_setting_dcb_get_priority_flow_control ()
void | nm_setting_dcb_set_priority_flow_control ()
NMSettingDcbFlags | nm_setting_dcb_get_priority_group_flags ()
guint | nm_setting_dcb_get_priority_group_id ()
void | nm_setting_dcb_set_priority_group_id ()
guint | nm_setting_dcb_get_priority_group_bandwidth ()
void | nm_setting_dcb_set_priority_group_bandwidth ()
guint | nm_setting_dcb_get_priority_bandwidth ()
void | nm_setting_dcb_set_priority_bandwidth ()
gboolean | nm_setting_dcb_get_priority_strict_bandwidth ()
void | nm_setting_dcb_set_priority_strict_bandwidth ()
guint | nm_setting_dcb_get_priority_traffic_class ()
void | nm_setting_dcb_set_priority_traffic_class ()

## Properties

NMSettingDcbFlags | app-fcoe-flags | Read / Write
gchar * | app-fcoe-mode | Read / Write / Construct
gint | app-fcoe-priority | Read / Write / Construct
NMSettingDcbFlags | app-fip-flags | Read / Write
gint | app-fip-priority | Read / Write / Construct
NMSettingDcbFlags | app-iscsi-flags | Read / Write
gint | app-iscsi-priority | Read / Write / Construct
GArray * | priority-bandwidth | Read / Write
GArray * | priority-flow-control | Read / Write
NMSettingDcbFlags | priority-flow-control-flags | Read / Write
GArray * | priority-group-bandwidth | Read / Write
NMSettingDcbFlags | priority-group-flags | Read / Write
GArray * | priority-group-id | Read / Write
GArray * | priority-strict-bandwidth | Read / Write
GArray * | priority-traffic-class | Read / Write

## Types and Values

#define | NM_SETTING_DCB_SETTING_NAME
enum | NMSettingDcbFlags
#define | NM_SETTING_DCB_FCOE_MODE_FABRIC
#define | NM_SETTING_DCB_FCOE_MODE_VN2VN
#define | NM_SETTING_DCB_APP_FCOE_FLAGS
#define | NM_SETTING_DCB_APP_FCOE_PRIORITY
#define | NM_SETTING_DCB_APP_FCOE_MODE
#define | NM_SETTING_DCB_APP_ISCSI_FLAGS
#define | NM_SETTING_DCB_APP_ISCSI_PRIORITY
#define | NM_SETTING_DCB_APP_FIP_FLAGS
#define | NM_SETTING_DCB_APP_FIP_PRIORITY
#define | NM_SETTING_DCB_PRIORITY_FLOW_CONTROL_FLAGS
#define | NM_SETTING_DCB_PRIORITY_FLOW_CONTROL
#define | NM_SETTING_DCB_PRIORITY_GROUP_FLAGS
#define | NM_SETTING_DCB_PRIORITY_GROUP_ID
#define | NM_SETTING_DCB_PRIORITY_GROUP_BANDWIDTH
#define | NM_SETTING_DCB_PRIORITY_BANDWIDTH
#define | NM_SETTING_DCB_PRIORITY_STRICT_BANDWIDTH
#define | NM_SETTING_DCB_PRIORITY_TRAFFIC_CLASS
| NMSettingDcb

## Object Hierarchy

        GFlags
        ╰── NMSettingDcbFlags
        GObject
        ╰── NMSetting
            ╰── NMSettingDcb

## Description

The NMSettingDcb object is a NMSetting subclass that describes properties for enabling and using Data Center Bridging (DCB) on Ethernet networks. DCB is a set of protocols (including 802.1Qbb, 802.1Qaz, 802.1Qau, and 802.1AB) to eliminate packet loss in Ethernet networks and support the use of storage technologies like Fibre Channel over Ethernet (FCoE) and iSCSI.

## Functions

### nm_setting_dcb_new ()

    NMSetting *
    nm_setting_dcb_new (void);

Creates a new NMSettingDcb object with default values.

#### Returns

the new empty NMSettingDcb object.

[transfer full]

### nm_setting_dcb_get_app_fcoe_flags ()

    NMSettingDcbFlags
    nm_setting_dcb_get_app_fcoe_flags (NMSettingDcb *setting);

#### Parameters

setting | the NMSettingDcb |

#### Returns

the “app-fcoe-flags” property of the setting

### nm_setting_dcb_get_app_fcoe_priority ()

    gint
    nm_setting_dcb_get_app_fcoe_priority (NMSettingDcb *setting);

#### Parameters

setting | the NMSettingDcb |

#### Returns

the “app-fcoe-priority” property of the setting

### nm_setting_dcb_get_app_fcoe_mode ()

    const char *
    nm_setting_dcb_get_app_fcoe_mode (NMSettingDcb *setting);

#### Parameters

setting | the NMSettingDcb |

#### Returns

the “app-fcoe-mode” property of the setting

### nm_setting_dcb_get_app_iscsi_flags ()

    NMSettingDcbFlags
    nm_setting_dcb_get_app_iscsi_flags (NMSettingDcb *setting);

#### Parameters

setting | the NMSettingDcb |

#### Returns

the “app-iscsi-flags” property of the setting

### nm_setting_dcb_get_app_iscsi_priority ()

    gint
    nm_setting_dcb_get_app_iscsi_priority (NMSettingDcb *setting);

#### Parameters

setting | the NMSettingDcb |

#### Returns

the “app-iscsi-priority” property of the setting

### nm_setting_dcb_get_app_fip_flags ()

    NMSettingDcbFlags
    nm_setting_dcb_get_app_fip_flags (NMSettingDcb *setting);

#### Parameters

setting | the NMSettingDcb |

#### Returns

the “app-fip-flags” property of the setting

### nm_setting_dcb_get_app_fip_priority ()

    gint
    nm_setting_dcb_get_app_fip_priority (NMSettingDcb *setting);

#### Parameters

setting | the NMSettingDcb |

#### Returns

the “app-fip-priority” property of the setting

### nm_setting_dcb_get_priority_flow_control_flags ()

    NMSettingDcbFlags
    nm_setting_dcb_get_priority_flow_control_flags
                                   (NMSettingDcb *setting);

#### Parameters

setting | the NMSettingDcb |

#### Returns

the “priority-flow-control-flags” property of the setting

### nm_setting_dcb_get_priority_flow_control ()

    gboolean
    nm_setting_dcb_get_priority_flow_control
                                   (NMSettingDcb *setting,
                                    guint user_priority);

#### Parameters

setting | the NMSettingDcb |
user_priority | the User Priority (0 - 7) to retrieve flow control for |

#### Returns

`TRUE` if flow control is enabled for the given `user_priority` , `FALSE` if not enabled

### nm_setting_dcb_set_priority_flow_control ()

    void
    nm_setting_dcb_set_priority_flow_control
                                   (NMSettingDcb *setting,
                                    guint user_priority,
                                    gboolean enabled);

These values are only valid when “priority-flow-control” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

#### Parameters

setting | the NMSettingDcb |
user_priority | the User Priority (0 - 7) to set flow control for |
enabled | `TRUE` to enable flow control for this priority, `FALSE` to disable it |

### nm_setting_dcb_get_priority_group_flags ()

    NMSettingDcbFlags
    nm_setting_dcb_get_priority_group_flags
                                   (NMSettingDcb *setting);

#### Parameters

setting | the NMSettingDcb |

#### Returns

the “priority-group-flags” property of the setting

### nm_setting_dcb_get_priority_group_id ()

    guint
    nm_setting_dcb_get_priority_group_id (NMSettingDcb *setting,
                                          guint user_priority);

#### Parameters

setting | the NMSettingDcb |
user_priority | the User Priority (0 - 7) to retrieve the group ID for |

#### Returns

the group number `user_priority` is assigned to. These values are only valid when “priority-group-flags” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

### nm_setting_dcb_set_priority_group_id ()

    void
    nm_setting_dcb_set_priority_group_id (NMSettingDcb *setting,
                                          guint user_priority,
                                          guint group_id);

These values are only valid when “priority-group-flags” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

#### Parameters

setting | the NMSettingDcb |
user_priority | the User Priority (0 - 7) to set flow control for |
group_id | the group (0 - 7) to assign `user_priority` to, or 15 for the unrestricted group. |

### nm_setting_dcb_get_priority_group_bandwidth ()

    guint
    nm_setting_dcb_get_priority_group_bandwidth
                                   (NMSettingDcb *setting,
                                    guint group_id);

#### Parameters

setting | the NMSettingDcb |
group_id | the priority group (0 - 7) to retrieve the bandwidth percentage for |

#### Returns

the bandwidth percentage assigned to `group_id` . These values are only valid when “priority-group-flags” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

### nm_setting_dcb_set_priority_group_bandwidth ()

    void
    nm_setting_dcb_set_priority_group_bandwidth
                                   (NMSettingDcb *setting,
                                    guint group_id,
                                    guint bandwidth_percent);

These values are only valid when “priority-group-flags” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

#### Parameters

setting | the NMSettingDcb |
group_id | the priority group (0 - 7) to set the bandwidth percentage for |
bandwidth_percent | the bandwidth percentage (0 - 100) to assign to `group_id` to |

### nm_setting_dcb_get_priority_bandwidth ()

    guint
    nm_setting_dcb_get_priority_bandwidth (NMSettingDcb *setting,
                                           guint user_priority);

#### Parameters

setting | the NMSettingDcb |
user_priority | the User Priority (0 - 7) to retrieve the group bandwidth percentage for |

#### Returns

the allowed bandwidth percentage of `user_priority` in its priority group. These values are only valid when “priority-group-flags” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

### nm_setting_dcb_set_priority_bandwidth ()

    void
    nm_setting_dcb_set_priority_bandwidth (NMSettingDcb *setting,
                                           guint user_priority,
                                           guint bandwidth_percent);

These values are only valid when “priority-group-flags” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

#### Parameters

setting | the NMSettingDcb |
user_priority | the User Priority (0 - 7) to set the bandwidth percentage for |
bandwidth_percent | the bandwidth percentage (0 - 100) that `user_priority` is allowed to use within its priority group |

### nm_setting_dcb_get_priority_strict_bandwidth ()

    gboolean
    nm_setting_dcb_get_priority_strict_bandwidth
                                   (NMSettingDcb *setting,
                                    guint user_priority);

#### Parameters

setting | the NMSettingDcb |
user_priority | the User Priority (0 - 7) to retrieve strict bandwidth for |

#### Returns

`TRUE` if `user_priority` may use all of the bandwidth allocated to its assigned group, or `FALSE` if not. These values are only valid when “priority-group-flags” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

### nm_setting_dcb_set_priority_strict_bandwidth ()

    void
    nm_setting_dcb_set_priority_strict_bandwidth
                                   (NMSettingDcb *setting,
                                    guint user_priority,
                                    gboolean strict);

These values are only valid when “priority-group-flags” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

#### Parameters

setting | the NMSettingDcb |
user_priority | the User Priority (0 - 7) to set strict bandwidth for |
strict | `TRUE` to allow `user_priority` to use all the bandwidth allocated to its priority group, or `FALSE` if not |

### nm_setting_dcb_get_priority_traffic_class ()

    guint
    nm_setting_dcb_get_priority_traffic_class
                                   (NMSettingDcb *setting,
                                    guint user_priority);

#### Parameters

setting | the NMSettingDcb |
user_priority | the User Priority (0 - 7) to retrieve the traffic class for |

#### Returns

the traffic class assigned to `user_priority` . These values are only valid when “priority-group-flags” includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

### nm_setting_dcb_set_priority_traffic_class ()

    void
    nm_setting_dcb_set_priority_traffic_class
                                   (NMSettingDcb *setting,
                                    guint user_priority,
                                    guint traffic_class);

## Types and Values

### NM_SETTING_DCB_SETTING_NAME

    #define NM_SETTING_DCB_SETTING_NAME "dcb"

### enum NMSettingDcbFlags

DCB feature flags.

#### Members

NM_SETTING_DCB_FLAG_NONE | no flag |
NM_SETTING_DCB_FLAG_ENABLE | the feature is enabled |
NM_SETTING_DCB_FLAG_ADVERTISE | the feature is advertised |
NM_SETTING_DCB_FLAG_WILLING | the feature is willing to change based on peer configuration advertisements |

### NM_SETTING_DCB_FCOE_MODE_FABRIC

    #define NM_SETTING_DCB_FCOE_MODE_FABRIC  "fabric"

Indicates that the FCoE controller should use "fabric" mode (default)

### NM_SETTING_DCB_FCOE_MODE_VN2VN

    #define NM_SETTING_DCB_FCOE_MODE_VN2VN   "vn2vn"

Indicates that the FCoE controller should use "VN2VN" mode.

### NM_SETTING_DCB_APP_FCOE_FLAGS

    #define NM_SETTING_DCB_APP_FCOE_FLAGS         "app-fcoe-flags"

### NM_SETTING_DCB_APP_FCOE_PRIORITY

    #define NM_SETTING_DCB_APP_FCOE_PRIORITY      "app-fcoe-priority"

### NM_SETTING_DCB_APP_FCOE_MODE

    #define NM_SETTING_DCB_APP_FCOE_MODE          "app-fcoe-mode"

### NM_SETTING_DCB_APP_ISCSI_FLAGS

    #define NM_SETTING_DCB_APP_ISCSI_FLAGS        "app-iscsi-flags"

### NM_SETTING_DCB_APP_ISCSI_PRIORITY

    #define NM_SETTING_DCB_APP_ISCSI_PRIORITY     "app-iscsi-priority"

### NM_SETTING_DCB_APP_FIP_FLAGS

    #define NM_SETTING_DCB_APP_FIP_FLAGS          "app-fip-flags"

### NM_SETTING_DCB_APP_FIP_PRIORITY

    #define NM_SETTING_DCB_APP_FIP_PRIORITY       "app-fip-priority"

### NM_SETTING_DCB_PRIORITY_FLOW_CONTROL_FLAGS

    #define NM_SETTING_DCB_PRIORITY_FLOW_CONTROL_FLAGS  "priority-flow-control-flags"

### NM_SETTING_DCB_PRIORITY_FLOW_CONTROL

    #define NM_SETTING_DCB_PRIORITY_FLOW_CONTROL        "priority-flow-control"

### NM_SETTING_DCB_PRIORITY_GROUP_FLAGS

    #define NM_SETTING_DCB_PRIORITY_GROUP_FLAGS      "priority-group-flags"

### NM_SETTING_DCB_PRIORITY_GROUP_ID

    #define NM_SETTING_DCB_PRIORITY_GROUP_ID         "priority-group-id"

### NM_SETTING_DCB_PRIORITY_GROUP_BANDWIDTH

    #define NM_SETTING_DCB_PRIORITY_GROUP_BANDWIDTH  "priority-group-bandwidth"

### NM_SETTING_DCB_PRIORITY_BANDWIDTH

    #define NM_SETTING_DCB_PRIORITY_BANDWIDTH        "priority-bandwidth"

### NM_SETTING_DCB_PRIORITY_STRICT_BANDWIDTH

    #define NM_SETTING_DCB_PRIORITY_STRICT_BANDWIDTH "priority-strict-bandwidth"

### NM_SETTING_DCB_PRIORITY_TRAFFIC_CLASS

    #define NM_SETTING_DCB_PRIORITY_TRAFFIC_CLASS    "priority-traffic-class"

### NMSettingDcb

    typedef struct _NMSettingDcb NMSettingDcb;

## Property Details

### The `“app-fcoe-flags”` property

      “app-fcoe-flags”           NMSettingDcbFlags

Specifies the NMSettingDcbFlags for the DCB FCoE application. Flags may be any combination of `NM_SETTING_DCB_FLAG_ENABLE`, `NM_SETTING_DCB_FLAG_ADVERTISE`, and `NM_SETTING_DCB_FLAG_WILLING`.

Flags: Read / Write

### The `“app-fcoe-mode”` property

      “app-fcoe-mode”            gchar *

The FCoE controller mode; either `NM_SETTING_DCB_FCOE_MODE_FABRIC` (default) or `NM_SETTING_DCB_FCOE_MODE_VN2VN`.

Flags: Read / Write / Construct

Default value: "fabric"

### The `“app-fcoe-priority”` property

      “app-fcoe-priority”        gint

The highest User Priority (0 - 7) which FCoE frames should use, or -1 for default priority. Only used when the “app-fcoe-flags” property includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

Flags: Read / Write / Construct

Allowed values: [-1,7]

Default value: -1

### The `“app-fip-flags”` property

      “app-fip-flags”            NMSettingDcbFlags

Specifies the NMSettingDcbFlags for the DCB FIP application. Flags may be any combination of `NM_SETTING_DCB_FLAG_ENABLE`, `NM_SETTING_DCB_FLAG_ADVERTISE`, and `NM_SETTING_DCB_FLAG_WILLING`.

Flags: Read / Write

### The `“app-fip-priority”` property

      “app-fip-priority”         gint

The highest User Priority (0 - 7) which FIP frames should use, or -1 for default priority. Only used when the “app-fip-flags” property includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

Flags: Read / Write / Construct

Allowed values: [-1,7]

Default value: -1

### The `“app-iscsi-flags”` property

      “app-iscsi-flags”          NMSettingDcbFlags

Specifies the NMSettingDcbFlags for the DCB iSCSI application. Flags may be any combination of `NM_SETTING_DCB_FLAG_ENABLE`, `NM_SETTING_DCB_FLAG_ADVERTISE`, and `NM_SETTING_DCB_FLAG_WILLING`.

Flags: Read / Write

### The `“app-iscsi-priority”` property

      “app-iscsi-priority”       gint

The highest User Priority (0 - 7) which iSCSI frames should use, or -1 for default priority. Only used when the “app-iscsi-flags” property includes the `NM_SETTING_DCB_FLAG_ENABLE` flag.

Flags: Read / Write / Construct

Allowed values: [-1,7]

Default value: -1

### The `“priority-bandwidth”` property

      “priority-bandwidth”       GArray *

An array of 8 uint values, where the array index corresponds to the User Priority (0 - 7) and the value indicates the percentage of bandwidth of the priority's assigned group that the priority may use. The sum of all percentages for priorities which belong to the same group must total 100 percent.

Element-type: guint

Flags: Read / Write

### The `“priority-flow-control”` property

      “priority-flow-control”    GArray *

An array of 8 boolean values, where the array index corresponds to the User Priority (0 - 7) and the value indicates whether or not the corresponding priority should transmit priority pause.

Element-type: gboolean

Flags: Read / Write

### The `“priority-flow-control-flags”` property

      “priority-flow-control-flags” NMSettingDcbFlags

Specifies the NMSettingDcbFlags for DCB Priority Flow Control (PFC). Flags may be any combination of `NM_SETTING_DCB_FLAG_ENABLE`, `NM_SETTING_DCB_FLAG_ADVERTISE`, and `NM_SETTING_DCB_FLAG_WILLING`.

Flags: Read / Write

### The `“priority-group-bandwidth”` property

      “priority-group-bandwidth” GArray *

An array of 8 uint values, where the array index corresponds to the Priority Group ID (0 - 7) and the value indicates the percentage of link bandwidth allocated to that group. Allowed values are 0 - 100, and the sum of all values must total 100 percent.

Element-type: guint

Flags: Read / Write

### The `“priority-group-flags”` property

      “priority-group-flags”     NMSettingDcbFlags

Specifies the NMSettingDcbFlags for DCB Priority Groups. Flags may be any combination of `NM_SETTING_DCB_FLAG_ENABLE`, `NM_SETTING_DCB_FLAG_ADVERTISE`, and `NM_SETTING_DCB_FLAG_WILLING`.

Flags: Read / Write

### The `“priority-group-id”` property

      “priority-group-id”        GArray *

An array of 8 uint values, where the array index corresponds to the User Priority (0 - 7) and the value indicates the Priority Group ID. Allowed Priority Group ID values are 0 - 7 or 15 for the unrestricted group.

Element-type: guint

Flags: Read / Write

### The `“priority-strict-bandwidth”` property

      “priority-strict-bandwidth” GArray *

An array of 8 boolean values, where the array index corresponds to the User Priority (0 - 7) and the value indicates whether or not the priority may use all of the bandwidth allocated to its assigned group.

Element-type: gboolean

Flags: Read / Write

### The `“priority-traffic-class”` property

      “priority-traffic-class”   GArray *

An array of 8 uint values, where the array index corresponds to the User Priority (0 - 7) and the value indicates the traffic class (0 - 7) to which the priority is mapped.

Element-type: guint

Flags: Read / Write